Page MenuHomePhabricator

Flow\Exception\FlowException from line 159 of Flow/includes/Formatter/ChangesListQuery.php: Revision not found in revisionCache
Closed, DeclinedPublic

Description

Noticed this error when viewing Special:RecentChanges on a 1.26.2 test wiki (the db was still not upgraded to 1.26 from 1.25 yet):

[8db7d018] /wiki/Special:RecentChanges Flow\Exception\FlowException from line 159 of /srv/mediawiki/w/extensions/Flow/includes/Formatter/ChangesListQuery.php: Revision not found in revisionCache: sv3f6bved6h0kihe

Backtrace:

#0 /srv/mediawiki/w/extensions/Flow/Hooks.php(506): Flow\Formatter\ChangesListQuery->getResult(EnhancedChangesList, RCCacheEntry, boolean)
#1 /srv/mediawiki/w/extensions/Flow/Hooks.php(490): FlowHooks::onEnhancedChangesListModifyBlockLineData(EnhancedChangesList, array, RCCacheEntry)
#2 /srv/mediawiki/w/includes/Hooks.php(201): FlowHooks::onEnhancedChangesListModifyLineData(EnhancedChangesList, array, array, RCCacheEntry)
#3 /srv/mediawiki/w/includes/changes/EnhancedChangesList.php(419): Hooks::run(string, array)
#4 /srv/mediawiki/w/includes/changes/EnhancedChangesList.php(276): EnhancedChangesList->getLineData(array, RCCacheEntry, array)
#5 /srv/mediawiki/w/includes/changes/EnhancedChangesList.php(683): EnhancedChangesList->recentChangesBlockGroup(array)
#6 /srv/mediawiki/w/includes/changes/EnhancedChangesList.php(103): EnhancedChangesList->recentChangesBlock()
#7 /srv/mediawiki/w/includes/specials/SpecialRecentchanges.php(356): EnhancedChangesList->recentChangesLine(RecentChange, boolean, integer)
#8 /srv/mediawiki/w/includes/specialpage/ChangesListSpecialPage.php(348): SpecialRecentChanges->outputChangesList(ResultWrapper, FormOptions)
#9 /srv/mediawiki/w/includes/specialpage/ChangesListSpecialPage.php(77): ChangesListSpecialPage->webOutput(ResultWrapper, FormOptions)
#10 /srv/mediawiki/w/includes/specials/SpecialRecentchanges.php(64): ChangesListSpecialPage->execute(NULL)
#11 /srv/mediawiki/w/includes/specialpage/SpecialPage.php(384): SpecialRecentChanges->execute(NULL)
#12 /srv/mediawiki/w/includes/specialpage/SpecialPageFactory.php(553): SpecialPage->run(NULL)
#13 /srv/mediawiki/w/includes/MediaWiki.php(281): SpecialPageFactory::executePath(Title, RequestContext)
#14 /srv/mediawiki/w/includes/MediaWiki.php(714): MediaWiki->performRequest()
#15 /srv/mediawiki/w/includes/MediaWiki.php(508): MediaWiki->main()
#16 /srv/mediawiki/w/index.php(41): MediaWiki->run()
#17 {main}

Tried to ran update.php on it:

Done 0 files in 0.0 seconds
Updating *_from_namespace fields in links tables.
...doing page_id from 1 to 200
Populating links tables...
Processing post spymgpj3pv7v8cya
Processing post sq196ojla9jx2zrm
Processing post sq2a02rybdvqk5g2
Processing post sqfyzamf4rnxxms2
Processing post sqfyzuotzsvs5tw2
Processing post sqfz0azp95melzte
Processing post sqfz225n5me823ki
Processing post sqxkg9x3t5ubyavm
Processing post sr09hrbv5vhuv5aq
Processing post ss0n5erk7t1smwlu
Processing post ss0n79hoowgk37v6
Processing post ss1w2648fej7qkr6
Processing post stt3ue6bc23ek1hu
Processing post stzezghhakmsc68i
Processing post su1l1vj5g065h1g2
Processing post su1ydy1ttszayaaa
Processing post su1yf12f9bnnp9ci
Processing post su208cx20g21fqtu
[cb5640fc] [no req]   Flow\Exception\FailCommitException from line 119 of /srv/mediawiki/w/extensions/Flow/includes/Model/Workflow.php: No page for workflow: O:19:"Flow\Model\Workflow":9:{s:5:"*id";O:15:"Flow\Model\UUID":1:{s:20:"*alphadecimalValue";s:16:"su208cwyw76qrdea";}s:7:"*type";s:5:"topic";s:7:"*wiki";s:22:"permanentfuturelabwiki";s:9:"*pageId";i:0;s:12:"*namespace";i:3;s:12:"*titleText";s:12:"Samir_Lahiri";s:14:"*lastUpdated";s:14:"20151206180950";s:8:"*title";N;s:13:"*ownerTitle";O:5:"Title":7:{s:10:"mNamespace";i:3;s:10:"mDbkeyform";s:12:"Samir_Lahiri";s:9:"mFragment";s:0:"";s:10:"mInterwiki";s:0:"";s:22:"TitlemLocalInterwiki";b:0;s:17:"*mUserCaseDBKey";s:12:"Samir_Lahiri";s:17:"mDefaultNamespace";i:0;}}
Backtrace:
#0 [internal function]: Flow\Model\Workflow::toStorageRow(Flow\Model\Workflow)
#1 /srv/mediawiki/w/extensions/Flow/includes/Data/Mapper/CachingObjectMapper.php(128): call_user_func(array, Flow\Model\Workflow)
#2 [internal function]: Flow\Data\Mapper\CachingObjectMapper->normalizeRow(array)
#3 /srv/mediawiki/w/extensions/Flow/includes/Data/Index/FeatureIndex.php(428): array_map(array, array)
#4 /srv/mediawiki/w/extensions/Flow/includes/Data/ObjectLocator.php(80): Flow\Data\Index\FeatureIndex->findMulti(array, array)
#5 /srv/mediawiki/w/extensions/Flow/includes/Data/ObjectLocator.php(195): Flow\Data\ObjectLocator->findMulti(array)
#6 /srv/mediawiki/w/extensions/Flow/includes/Data/ObjectLocator.php(169): Flow\Data\ObjectLocator->getMulti(array)
#7 /srv/mediawiki/w/extensions/Flow/includes/Collection/AbstractCollection.php(230): Flow\Data\ObjectLocator->get(Flow\Model\UUID)
#8 /srv/mediawiki/w/extensions/Flow/maintenance/FlowPopulateLinksTables.php(105): Flow\Collection\AbstractCollection->getWorkflow()
#9 /srv/mediawiki/w/extensions/Flow/maintenance/FlowPopulateLinksTables.php(31): FlowPopulateLinksTables->processPosts(Flow\Data\Listener\ReferenceRecorder)
#10 /srv/mediawiki/w/maintenance/Maintenance.php(1318): FlowPopulateLinksTables->doDBUpdates()
#11 /srv/mediawiki/w/maintenance/update.php(181): LoggedUpdateMaintenance->execute()
#12 /srv/mediawiki/w/maintenance/doMaintenance.php(103): UpdateMediaWiki->execute()
#13 /srv/mediawiki/w/maintenance/update.php(214): require_once(string)
#14 {main}

Configuration:
https://github.com/miraheze/mw-config/blob/fa03000177393523085ae42642769137a23a4b98/LocalSettings.php
https://github.com/miraheze/mw-config/blob/fa03000177393523085ae42642769137a23a4b98/LocalExtensions.php#L35
Flow's REL1_26 branch (981e2ff36c2c4020617e69b71e35c084cba7013d)
MediaWiki 1.26.2, HHVM 3.9.1, MariaDB 10.0, Debian 8
https://permanentfuturelab.wiki/wiki/Special:RecentChanges (note: DNS routes you to a production MediaWiki 1.25 server. This error was reproduced on MediaWiki 1.26.)

Event Timeline

Southparkfan raised the priority of this task from to High.
Southparkfan updated the task description. (Show Details)
Southparkfan added a subscriber: Southparkfan.
Restricted Application added a project: Collaboration-Team-Triage. · View Herald TranscriptDec 23 2015, 7:42 PM
Restricted Application added a subscriber: Aklapper. · View Herald Transcript

Change 260800 had a related patch set uploaded (by Mattflaschen):
WIP: Move up FlowUpdateWorkflowPageId

https://gerrit.wikimedia.org/r/260800

It seems you have a corrupt row in your database.

The script causing issues is FlowPopulateLinksTables.php, which populates the Flow link tables.

That doesn't create any workflows, and all the workflows should have a valid page ID before the script runs (the logic that throws that exception is intended for initial inserts).

It looks like one of the rows in your database is missing a workflow_page_id.

  1. Make sure you have a database backup (preferably from before you started upgrading, but still worth taking one now if not).
  2. To see the extent of the problem, run:
SELECT LOWER(HEX(workflow_id)), workflow_page_id, workflow_namespace, workflow_title_text, workflow_type FROM flow_workflow WHERE workflow_page_id = 0;

I've put up a patch (https://gerrit.wikimedia.org/r/260800) that may fix it for you. Basically, it moves FlowUpdateWorkflowPageId two up in the update.php order.

Please let me know what happens.

Output of your SQL:

MariaDB [permanentfuturelabwiki]> SELECT LOWER(HEX(workflow_id)), workflow_page_id, workflow_namespace, workflow_title_text, workflow_type FROM flow_workflow WHERE workflow_page_id = 0;
+-------------------------+------------------+--------------------+-------------------------------+---------------+
| LOWER(HEX(workflow_id)) | workflow_page_id | workflow_namespace | workflow_title_text           | workflow_type |
+-------------------------+------------------+--------------------+-------------------------------+---------------+
| 05408ef50a9777c2311e92  |                0 |                  1 | Seats2meet.com_Utrecht_CS     | discussion    |
| 05408ef518e37738d3a20f  |                0 |                  1 | Locations                     | discussion    |
| 05408ef52253774ee7bd24  |                0 |                  1 | Permanent_Future_Lab_Wiki     | discussion    |
| 05408ef52ba37749baa777  |                0 |                  1 | Sharing                       | discussion    |
| 05408ef53c1b772e3a5852  |                0 |                  1 | Core_values                   | discussion    |
| 05408ef7309777c2311e92  |                0 |                  3 | Jurjendevries                 | discussion    |
| 05408ef73f4777fbfb46ec  |                0 |                  3 | NDKilla                       | discussion    |
| 05408ef744cf7735ef09dd  |                0 |                  3 | BartWR                        | discussion    |
| 05408ef74d777717319059  |                0 |                  3 | Donfelicio                    | discussion    |
| 05408ef7532b77d1d69fc6  |                0 |                  3 | Beeldend_David                | discussion    |
| 05408ef7594377bee007dd  |                0 |                  3 | JurjenS                       | discussion    |
| 05408ef75f77778a659a4a  |                0 |                  3 | Outdoorhans                   | discussion    |
| 05408ef765ef775d92bc71  |                0 |                  3 | Mo                            | discussion    |
| 05408ef76b53777dad9435  |                0 |                  3 | Edoderoo                      | discussion    |
| 05408ef7726b77c99566ac  |                0 |                  3 | Ankehans                      | discussion    |
| 0545e1f13031dfc2311e92  |                0 |                  3 | Samir_Lahiri                  | discussion    |
| 0545e1f1303ddfc2311e92  |                0 |                  3 | Samir_Lahiri                  | topic         |
| 0545efa11159dfc2311e92  |                0 |                  3 | Jel_van_Rijn                  | discussion    |
| 0545efa11165dfc2311e92  |                0 |                  3 | Jel_van_Rijn                  | topic         |
| 05473b970449dfc2311e92  |                0 |                  1 | Permanent_Future_Lab_Strijp-S | discussion    |
| 05473b970459dfc2311e92  |                0 |                  1 | Permanent_Future_Lab_Strijp-S | topic         |
+-------------------------+------------------+--------------------+-------------------------------+---------------+
21 rows in set (0.00 sec)

When applying your patch I still got the same error, although I must note that I did not revert the database into its first state (before I ran update.php for the first time). I'll do that now.

NB: I'm actually not sure whether I got the same error after I applied your patch. Please discard that comment.

Got the following output in update.php after applying your patch (and reverting database to the '1.25 version'):

Done 0 files in 0.0 seconds
Updating *_from_namespace fields in links tables.
...doing page_id from 1 to 200
Updated 15  workflows
Failed: 6

Array
(
    [0] => stdClass Object
        (
            [workflow_id] => E▒▒01▒▒1▒
            [workflow_wiki] => permanentfuturelabwiki
            [workflow_namespace] => 3
            [workflow_page_id] => 0
            [workflow_title_text] => Samir_Lahiri
            [workflow_name] =>
            [workflow_last_update_timestamp] => 20151206180950
            [workflow_lock_state] => 0
            [workflow_type] => discussion
        )

    [1] => stdClass Object
        (
            [workflow_id] => E▒▒0=▒▒1▒
            [workflow_wiki] => permanentfuturelabwiki
            [workflow_namespace] => 3
            [workflow_page_id] => 0
            [workflow_title_text] => Samir_Lahiri
            [workflow_name] =>
            [workflow_last_update_timestamp] => 20151206180950
            [workflow_lock_state] => 0
            [workflow_type] => topic
        )

    [2] => stdClass Object
        (
            [workflow_id] => E▒Y▒▒1▒
            [workflow_wiki] => permanentfuturelabwiki
            [workflow_namespace] => 3
            [workflow_page_id] => 0
            [workflow_title_text] => Jel_van_Rijn
            [workflow_name] =>
            [workflow_last_update_timestamp] => 20151207100638
            [workflow_lock_state] => 0
            [workflow_type] => discussion
        )

    [3] => stdClass Object
        (
            [workflow_id] => E▒e▒▒1▒
            [workflow_wiki] => permanentfuturelabwiki
            [workflow_namespace] => 3
            [workflow_page_id] => 0
            [workflow_title_text] => Jel_van_Rijn
            [workflow_name] =>
            [workflow_last_update_timestamp] => 20151207105225
            [workflow_lock_state] => 0
            [workflow_type] => topic
        )

    [4] => stdClass Object
        (
            [workflow_id] => G;▒I▒▒1▒
            [workflow_wiki] => permanentfuturelabwiki
            [workflow_namespace] => 1
            [workflow_page_id] => 0
            [workflow_title_text] => Permanent_Future_Lab_Strijp-S
            [workflow_name] =>
            [workflow_last_update_timestamp] => 20151223125222
            [workflow_lock_state] => 0
            [workflow_type] => discussion
        )

    [5] => stdClass Object
        (
            [workflow_id] => G;▒Y▒▒1▒
            [workflow_wiki] => permanentfuturelabwiki
            [workflow_namespace] => 1
            [workflow_page_id] => 0
            [workflow_title_text] => Permanent_Future_Lab_Strijp-S
            [workflow_name] =>
            [workflow_last_update_timestamp] => 20151223131605
            [workflow_lock_state] => 0
            [workflow_type] => topic
        )

)
Populating links tables...
PuTTYPuTTYPuTTYPuTTYPuTTYPuTTYProcessing post spymgpj3pv7v8cya
Processing post sq196ojla9jx2zrm
Processing post sq2a02rybdvqk5g2
Processing post sqfyzamf4rnxxms2
Processing post sqfyzuotzsvs5tw2
Processing post sqfz0azp95melzte
Processing post sqfz225n5me823ki
Processing post sqxkg9x3t5ubyavm
Processing post sr09hrbv5vhuv5aq
Processing post ss0n5erk7t1smwlu
Processing post ss0n79hoowgk37v6
Processing post ss1w2648fej7qkr6
Processing post stt3ue6bc23ek1hu
Processing post stzezghhakmsc68i
Processing post su1l1vj5g065h1g2
Processing post su1ydy1ttszayaaa
Processing post su1yf12f9bnnp9ci
Processing post su208cx20g21fqtu
[COMMENT HERE: sorry for the messed up aligning of the first line of the exception error]
[5a43ab58] [no req]   Flow\Exception\FailCommitException from line 119 of /srv/mediawiki/w/extensions/Flow/includes/Model/Workflow.php: No page for workflow: O:19:"Flow\Model\Workflow":9                                                                                    :{s:5:"*id";O:15:"Flow\Model\UUID":1:{s:20:"*alphadecimalValue";s:16:"su208cwyw76qrdea";}s:7:                                                                                    "*type";s:5:"topic";s:7:"*wiki";s:22:"permanentfuturelabwiki";s:9:"*pageId";i:0;s:12:"*namesp                                                                                    ace";i:3;s:12:"*titleText";s:12:"Samir_Lahiri";s:14:"*lastUpdated";s:14:"20151206180950";s:8:                                                                                    "*title";N;s:13:"*ownerTitle";O:5:"Title":7:{s:10:"mNamespace";i:3;s:10:"mDbkeyform";s:12:"Sa                                                                                    mir_Lahiri";s:9:"mFragment";s:0:"";s:10:"mInterwiki";s:0:"";s:22:"TitlemLocalInterwiki";b:0;s                                                                                    :17:"*mUserCaseDBKey";s:12:"Samir_Lahiri";s:17:"mDefaultNamespace";i:0;}}
Backtrace:
#0 [internal function]: Flow\Model\Workflow::toStorageRow(Flow\Model\Workflow)
#1 /srv/mediawiki/w/extensions/Flow/includes/Data/Mapper/CachingObjectMapper.php(128): call_user_func(array, Flow\Model\Workflow)
#2 [internal function]: Flow\Data\Mapper\CachingObjectMapper->normalizeRow(array)
#3 /srv/mediawiki/w/extensions/Flow/includes/Data/Index/FeatureIndex.php(428): array_map(array, array)
#4 /srv/mediawiki/w/extensions/Flow/includes/Data/ObjectLocator.php(80): Flow\Data\Index\FeatureIndex->findMulti(array, array)
#5 /srv/mediawiki/w/extensions/Flow/includes/Data/ObjectLocator.php(195): Flow\Data\ObjectLocator->findMulti(array)
#6 /srv/mediawiki/w/extensions/Flow/includes/Data/ObjectLocator.php(169): Flow\Data\ObjectLocator->getMulti(array)
#7 /srv/mediawiki/w/extensions/Flow/includes/Collection/AbstractCollection.php(230): Flow\Data\ObjectLocator->get(Flow\Model\UUID)
#8 /srv/mediawiki/w/extensions/Flow/maintenance/FlowPopulateLinksTables.php(105): Flow\Collection\AbstractCollection->getWorkflow()
#9 /srv/mediawiki/w/extensions/Flow/maintenance/FlowPopulateLinksTables.php(31): FlowPopulateLinksTables->processPosts(Flow\Data\Listener\ReferenceRecorder)
#10 /srv/mediawiki/w/maintenance/Maintenance.php(1318): FlowPopulateLinksTables->doDBUpdates()
#11 /srv/mediawiki/w/maintenance/update.php(181): LoggedUpdateMaintenance->execute()
#12 /srv/mediawiki/w/maintenance/doMaintenance.php(103): UpdateMediaWiki->execute()
#13 /srv/mediawiki/w/maintenance/update.php(214): require_once(string)
#14 {main}

Change 260902 had a related patch set uploaded (by Mattflaschen):
DO NOT MERGE: Output exception to help track down an issue

https://gerrit.wikimedia.org/r/260902

There are 21 bad rows, of which it is able to fix 15.

These (e.g. https://permanentfuturelab.wiki/wiki/User_talk:Samir_Lahiri) are Flow boards, but the pages do not exist. This is a former inconsistent state issue (since fixed for new boards) that this script is also meant to fix. However, for these 6, it is apparently not able to fix it.

To see why, please apply https://gerrit.wikimedia.org/r/260902 on top of REL1_26, then either run just FlowUpdateWorkflowPageId.php or run update.php again.

Thanks for reporting this issue.

I got this:

Updated 15  workflows
Failed: 6

Array
(
    [0] => stdClass Object
        (
            [workflow_id] => E▒▒01▒▒1▒
            [workflow_wiki] => permanentfuturelabwiki
            [workflow_namespace] => 3
            [workflow_page_id] => 0
            [workflow_title_text] => Samir_Lahiri
            [workflow_name] =>
            [workflow_last_update_timestamp] => 20151206180950
            [workflow_lock_state] => 0
            [workflow_type] => discussion
        )

    [1] => stdClass Object
        (
            [workflow_id] => E▒▒0=▒▒1▒
            [workflow_wiki] => permanentfuturelabwiki
            [workflow_namespace] => 3
            [workflow_page_id] => 0
            [workflow_title_text] => Samir_Lahiri
            [workflow_name] =>
            [workflow_last_update_timestamp] => 20151206180950
            [workflow_lock_state] => 0
            [workflow_type] => topic
        )

    [2] => stdClass Object
        (
            [workflow_id] => E▒Y▒▒1▒
            [workflow_wiki] => permanentfuturelabwiki
            [workflow_namespace] => 3
            [workflow_page_id] => 0
            [workflow_title_text] => Jel_van_Rijn
            [workflow_name] =>
            [workflow_last_update_timestamp] => 20151207100638
            [workflow_lock_state] => 0
            [workflow_type] => discussion
        )

    [3] => stdClass Object
        (
            [workflow_id] => E▒e▒▒1▒
            [workflow_wiki] => permanentfuturelabwiki
            [workflow_namespace] => 3
            [workflow_page_id] => 0
            [workflow_title_text] => Jel_van_Rijn
            [workflow_name] =>
            [workflow_last_update_timestamp] => 20151207105225
            [workflow_lock_state] => 0
            [workflow_type] => topic
        )

    [4] => stdClass Object
        (
            [workflow_id] => G;▒I▒▒1▒
            [workflow_wiki] => permanentfuturelabwiki
            [workflow_namespace] => 1
            [workflow_page_id] => 0
            [workflow_title_text] => Permanent_Future_Lab_Strijp-S
            [workflow_name] =>
            [workflow_last_update_timestamp] => 20151223125222
            [workflow_lock_state] => 0
            [workflow_type] => discussion
        )

    [5] => stdClass Object
        (
            [workflow_id] => G;▒Y▒▒1▒
            [workflow_wiki] => permanentfuturelabwiki
            [workflow_namespace] => 1
            [workflow_page_id] => 0
            [workflow_title_text] => Permanent_Future_Lab_Strijp-S
            [workflow_name] =>
            [workflow_last_update_timestamp] => 20151223213826
            [workflow_lock_state] => 0
            [workflow_type] => topic
        )

)

when running FlowUpdateWorkflowPageId.php. Your patch didn't change anything (I tried echo $e->getMessage() too, but no result?).

Catrope added a subscriber: Catrope.
Mattflaschen-WMF added a comment.EditedJan 14 2016, 6:41 AM

I updated the troubleshooting patch (https://gerrit.wikimedia.org/r/#/c/260902/2). Please re-run and provide the output.

root@mw1:/srv/mediawiki/w/extensions/Flow/maintenance# php FlowUpdateWorkflowPageId.php --wiki permanentfuturelabwiki --force
Updated 0  workflows
Failed: 6

Array
(
    [0] => Array
        (
            [0] => stdClass Object
                (
                    [workflow_id] => E▒▒01▒▒1▒
                    [workflow_wiki] => permanentfuturelabwiki
                    [workflow_namespace] => 3
                    [workflow_page_id] => 0
                    [workflow_title_text] => Samir_Lahiri
                    [workflow_name] =>
                    [workflow_last_update_timestamp] => 20151206180950
                    [workflow_lock_state] => 0
                    [workflow_type] => discussion
                )

            [1] => Array
                (
                    [0] => Could not find new article ID corresponding to workflow
                )

        )

    [1] => Array
        (
            [0] => stdClass Object
                (
                    [workflow_id] => E▒▒0=▒▒1▒
                    [workflow_wiki] => permanentfuturelabwiki
                    [workflow_namespace] => 3
                    [workflow_page_id] => 0
                    [workflow_title_text] => Samir_Lahiri
                    [workflow_name] =>
                    [workflow_last_update_timestamp] => 20151206180950
                    [workflow_lock_state] => 0
                    [workflow_type] => topic
                )

            [1] => Array
                (
                    [0] => Could not find new article ID corresponding to workflow
                )

        )

    [2] => Array
        (
            [0] => stdClass Object
                (
                    [workflow_id] => E▒Y▒▒1▒
                    [workflow_wiki] => permanentfuturelabwiki
                    [workflow_namespace] => 3
                    [workflow_page_id] => 0
                    [workflow_title_text] => Jel_van_Rijn
                    [workflow_name] =>
                    [workflow_last_update_timestamp] => 20151207100638
                    [workflow_lock_state] => 0
                    [workflow_type] => discussion
                )

            [1] => Array
                (
                    [0] => Could not find new article ID corresponding to workflow
                )

        )

    [3] => Array
        (
            [0] => stdClass Object
                (
                    [workflow_id] => E▒e▒▒1▒
                    [workflow_wiki] => permanentfuturelabwiki
                    [workflow_namespace] => 3
                    [workflow_page_id] => 0
                    [workflow_title_text] => Jel_van_Rijn
                    [workflow_name] =>
                    [workflow_last_update_timestamp] => 20151207105225
                    [workflow_lock_state] => 0
                    [workflow_type] => topic
                )

            [1] => Array
                (
                    [0] => Could not find new article ID corresponding to workflow
                )

        )

    [4] => Array
        (
            [0] => stdClass Object
                (
                    [workflow_id] => G;▒I▒▒1▒
                    [workflow_wiki] => permanentfuturelabwiki
                    [workflow_namespace] => 1
                    [workflow_page_id] => 0
                    [workflow_title_text] => Permanent_Future_Lab_Strijp-S
                    [workflow_name] =>
                    [workflow_last_update_timestamp] => 20151223125222
                    [workflow_lock_state] => 0
                    [workflow_type] => discussion
                )

            [1] => Array
                (
                    [0] => Could not find new article ID corresponding to workflow
                )

        )

    [5] => Array
        (
            [0] => stdClass Object
                (
                    [workflow_id] => G;▒Y▒▒1▒
                    [workflow_wiki] => permanentfuturelabwiki
                    [workflow_namespace] => 1
                    [workflow_page_id] => 0
                    [workflow_title_text] => Permanent_Future_Lab_Strijp-S
                    [workflow_name] =>
                    [workflow_last_update_timestamp] => 20151223213826
                    [workflow_lock_state] => 0
                    [workflow_type] => topic
                )

            [1] => Array
                (
                    [0] => Could not find new article ID corresponding to workflow
                )

        )

)

@matthiasmullie Have any thoughts? It's almost like it's failing to create the page, but not falling into the exception block.

I don't really know why this would be happening. But we indeed have very poor error reporting here (various cases of "failing to create page" are not covered & reported).
I've submitted another patch that should provide more details when it fails to create a page.

Change 265707 had a related patch set uploaded (by Matthias Mullie):
Check for & report result of fatal Status objs returned by occupationcontroller

https://gerrit.wikimedia.org/r/265707

Didn't really get more information:

root@mw1:/srv/mediawiki/w/extensions/Flow/maintenance# php FlowUpdateWorkflowPageId.php --wiki permanentfuturelabwiki --force                                                    Updated 0  workflows

Warnings: 0
Array
(
)


Failed: 6
Array
(
    [0] => stdClass Object
        (
            [workflow_id] => E▒▒01▒▒1▒
            [workflow_wiki] => permanentfuturelabwiki
            [workflow_namespace] => 3
            [workflow_page_id] => 0
            [workflow_title_text] => Samir_Lahiri
            [workflow_name] =>
            [workflow_last_update_timestamp] => 20151206180950
            [workflow_lock_state] => 0
            [workflow_type] => discussion
        )

    [1] => stdClass Object
        (
            [workflow_id] => E▒▒0=▒▒1▒
            [workflow_wiki] => permanentfuturelabwiki
            [workflow_namespace] => 3
            [workflow_page_id] => 0
            [workflow_title_text] => Samir_Lahiri
            [workflow_name] =>
            [workflow_last_update_timestamp] => 20151206180950
            [workflow_lock_state] => 0
            [workflow_type] => topic
        )

    [2] => stdClass Object
        (
            [workflow_id] => E▒Y▒▒1▒
            [workflow_wiki] => permanentfuturelabwiki
            [workflow_namespace] => 3
            [workflow_page_id] => 0
            [workflow_title_text] => Jel_van_Rijn
            [workflow_name] =>
            [workflow_last_update_timestamp] => 20151207100638
            [workflow_lock_state] => 0
            [workflow_type] => discussion
        )

    [3] => stdClass Object
        (
            [workflow_id] => E▒e▒▒1▒
            [workflow_wiki] => permanentfuturelabwiki
            [workflow_namespace] => 3
            [workflow_page_id] => 0
            [workflow_title_text] => Jel_van_Rijn
            [workflow_name] =>
            [workflow_last_update_timestamp] => 20151207105225
            [workflow_lock_state] => 0
            [workflow_type] => topic
        )

    [4] => stdClass Object
        (
            [workflow_id] => G;▒I▒▒1▒
            [workflow_wiki] => permanentfuturelabwiki
            [workflow_namespace] => 1
            [workflow_page_id] => 0
            [workflow_title_text] => Permanent_Future_Lab_Strijp-S
            [workflow_name] =>
            [workflow_last_update_timestamp] => 20151223125222
            [workflow_lock_state] => 0
            [workflow_type] => discussion
        )

    [5] => stdClass Object
        (
            [workflow_id] => G;▒Y▒▒1▒
            [workflow_wiki] => permanentfuturelabwiki
            [workflow_namespace] => 1
            [workflow_page_id] => 0
            [workflow_title_text] => Permanent_Future_Lab_Strijp-S
            [workflow_name] =>
            [workflow_last_update_timestamp] => 20151223213826
            [workflow_lock_state] => 0
            [workflow_type] => topic
        )

)

Bleh, that check to see if the page should be created was strict (comparing to an int, when value from DB is a string), so it likely never even attempted to create the missing page.
I've just updated the patch - can you take it for another run please?

root@mw1:/srv/mediawiki/w/extensions/Flow/maintenance# php FlowUpdateWorkflowPageId.php --wiki permanentfuturelabwiki --force
PHP Notice:  Undefined property: stdClass::$workflowId in /srv/mediawiki/w/extensions/Flow/maintenance/FlowUpdateWorkflowPageId.php on line 98

Notice: Undefined property: stdClass::$workflowId in /srv/mediawiki/w/extensions/Flow/maintenance/FlowUpdateWorkflowPageId.php on line 98
PHP Catchable fatal error:  Argument 2 passed to WorkflowPageIdUpdateGenerator::createPage() must be an instance of Flow\Model\UUID, null given, called in /srv/mediawiki/w/extensions/Flow/maintenance/FlowUpdateWorkflowPageId.php on line 98 and defined in /srv/mediawiki/w/extensions/Flow/maintenance/FlowUpdateWorkflowPageId.php on line 127

Catchable fatal error: Argument 2 passed to WorkflowPageIdUpdateGenerator::createPage() must be an instance of Flow\Model\UUID, null given, called in /srv/mediawiki/w/extensions/Flow/maintenance/FlowUpdateWorkflowPageId.php on line 98 and defined in /srv/mediawiki/w/extensions/Flow/maintenance/FlowUpdateWorkflowPageId.php on line 127

Yeah sorry, that was sloppy from me - that camelcased property name was obviously wrong - not sure how that slipped in there.
Anyway, it looks like we're making progress though - last time we didn't seem to reach that part of the code (that bug was there already).
Can you run the current (fixed) version yet again, please? :)

[b8761ba3] [no req]   Flow\Exception\FailCommitException from line 119 of /srv/mediawiki/w/extensions/Flow/includes/Model/Workflow.php: No page for workflow: O:19:"Flow\Model\Workflow":9:{s:5:"*id";O:15:"Flow\Model\UUID":1:{s:20:"*alphadecimalValue";s:16:"su208cwu7tvsqt8y";}s:7:"*type";s:10:"discussion";s:7:"*wiki";s:22:"permanentfuturelabwiki";s:9:"*pageId";i:0;s:12:"*namespace";i:3;s:12:"*titleText";s:12:"Samir_Lahiri";s:14:"*lastUpdated";s:14:"20151206180950";s:8:"*title";N;s:13:"*ownerTitle";O:5:"Title":7:{s:10:"mNamespace";i:3;s:10:"mDbkeyform";s:12:"Samir_Lahiri";s:9:"mFragment";s:0:"";s:10:"mInterwiki";s:0:"";s:22:"TitlemLocalInterwiki";b:0;s:17:"*mUserCaseDBKey";s:12:"Samir_Lahiri";s:17:"mDefaultNamespace";i:0;}}
Backtrace:
#0 [internal function]: Flow\Model\Workflow::toStorageRow(Flow\Model\Workflow)
#1 /srv/mediawiki/w/extensions/Flow/includes/Data/Mapper/CachingObjectMapper.php(128): call_user_func(array, Flow\Model\Workflow)
#2 [internal function]: Flow\Data\Mapper\CachingObjectMapper->normalizeRow(array)
#3 /srv/mediawiki/w/extensions/Flow/includes/Data/Index/FeatureIndex.php(428): array_map(array, array)
#4 /srv/mediawiki/w/extensions/Flow/includes/Data/ObjectLocator.php(80): Flow\Data\Index\FeatureIndex->findMulti(array, array)
#5 /srv/mediawiki/w/extensions/Flow/includes/Data/ObjectLocator.php(195): Flow\Data\ObjectLocator->findMulti(array)
#6 /srv/mediawiki/w/extensions/Flow/includes/Data/ObjectLocator.php(169): Flow\Data\ObjectLocator->getMulti(array)
#7 [internal function]: Flow\Data\ObjectLocator->get(Flow\Model\UUID)
#8 /srv/mediawiki/w/extensions/Flow/includes/Data/ManagerGroup.php(129): call_user_func_array(array, array)
#9 /srv/mediawiki/w/extensions/Flow/includes/Data/ManagerGroup.php(133): Flow\Data\ManagerGroup->call(string, array)
#10 /srv/mediawiki/w/extensions/Flow/maintenance/FlowUpdateWorkflowPageId.php(133): Flow\Data\ManagerGroup->get(string, Flow\Model\UUID)
#11 /srv/mediawiki/w/extensions/Flow/maintenance/FlowUpdateWorkflowPageId.php(98): WorkflowPageIdUpdateGenerator->createPage(Title, Flow\Model\UUID)
#12 /srv/mediawiki/w/extensions/Echo/includes/BatchRowUpdate.php(88): WorkflowPageIdUpdateGenerator->update(stdClass)
#13 /srv/mediawiki/w/extensions/Flow/maintenance/FlowUpdateWorkflowPageId.php(51): EchoBatchRowUpdate->execute()
#14 /srv/mediawiki/w/maintenance/Maintenance.php(1318): FlowUpdateWorkflowPageId->doDbUpdates()
#15 /srv/mediawiki/w/maintenance/doMaintenance.php(103): LoggedUpdateMaintenance->execute()
#16 /srv/mediawiki/w/extensions/Flow/maintenance/FlowUpdateWorkflowPageId.php(165): require_once(string)
#17 {main}

I've just updated the patch - can you try again please, @Southparkfan?

You may also want to update your Flow extension - the thing that was causing this particular error doesn't exist in the current version anymore (but the updated patch should now work regardless)

(Sorry for any garbled output, this was sent from my phone)

root@mw1:/srv/mediawiki/w/extensions/Flow/maintenance# php FlowUpdateWorkflowPageId.php --wiki permanentfuturelabwiki --force
Updated 0  workflows

Warnings: 6
Array
(
    [0] => No page for workflow: O:19:"Flow\Model\Workflow":9:{s:5:"*id";O:15:"Flow\Model\UUID":1:{s:20:"*alphadecimalValue";s:16:"su208cwu7tvsqt8y";}s:7:"*type";s:10:"discussion";s:7:"*wiki";s:22:"permanentfuturelabwiki";s:9:"*pageId";i:0;s:12:"*namespace";i:3;s:12:"*titleText";s:12:"Samir_Lahiri";s:14:"*lastUpdated";s:14:"20151206180950";s:8:"*title";N;s:13:"*ownerTitle";O:5:"Title":7:{s:10:"mNamespace";i:3;s:10:"mDbkeyform";s:12:"Samir_Lahiri";s:9:"mFragment";s:0:"";s:10:"mInterwiki";s:0:"";s:22:"TitlemLocalInterwiki";b:0;s:17:"*mUserCaseDBKey";s:12:"Samir_Lahiri";s:17:"mDefaultNamespace";i:0;}}
    [1] => No page for workflow: O:19:"Flow\Model\Workflow":9:{s:5:"*id";O:15:"Flow\Model\UUID":1:{s:20:"*alphadecimalValue";s:16:"su208cwyw76qrdea";}s:7:"*type";s:5:"topic";s:7:"*wiki";s:22:"permanentfuturelabwiki";s:9:"*pageId";i:0;s:12:"*namespace";i:3;s:12:"*titleText";s:12:"Samir_Lahiri";s:14:"*lastUpdated";s:14:"20151206180950";s:8:"*title";N;s:13:"*ownerTitle";O:5:"Title":7:{s:10:"mNamespace";i:3;s:10:"mDbkeyform";s:12:"Samir_Lahiri";s:9:"mFragment";s:0:"";s:10:"mInterwiki";s:0:"";s:22:"TitlemLocalInterwiki";b:0;s:17:"*mUserCaseDBKey";s:12:"Samir_Lahiri";s:17:"mDefaultNamespace";i:0;}}
    [2] => No page for workflow: O:19:"Flow\Model\Workflow":9:{s:5:"*id";O:15:"Flow\Model\UUID":1:{s:20:"*alphadecimalValue";s:16:"su3hilb4dxail6ky";}s:7:"*type";s:10:"discussion";s:7:"*wiki";s:22:"permanentfuturelabwiki";s:9:"*pageId";i:0;s:12:"*namespace";i:3;s:12:"*titleText";s:12:"Jel_van_Rijn";s:14:"*lastUpdated";s:14:"20151207100638";s:8:"*title";N;s:13:"*ownerTitle";O:5:"Title":7:{s:10:"mNamespace";i:3;s:10:"mDbkeyform";s:12:"Jel_van_Rijn";s:9:"mFragment";s:0:"";s:10:"mInterwiki";s:0:"";s:22:"TitlemLocalInterwiki";b:0;s:17:"*mUserCaseDBKey";s:12:"Jel_van_Rijn";s:17:"mDefaultNamespace";i:0;}}
    [3] => No page for workflow: O:19:"Flow\Model\Workflow":9:{s:5:"*id";O:15:"Flow\Model\UUID":1:{s:20:"*alphadecimalValue";s:16:"su3hilb92alglqqa";}s:7:"*type";s:5:"topic";s:7:"*wiki";s:22:"permanentfuturelabwiki";s:9:"*pageId";i:0;s:12:"*namespace";i:3;s:12:"*titleText";s:12:"Jel_van_Rijn";s:14:"*lastUpdated";s:14:"20151207105225";s:8:"*title";N;s:13:"*ownerTitle";O:5:"Title":7:{s:10:"mNamespace";i:3;s:10:"mDbkeyform";s:12:"Jel_van_Rijn";s:9:"mFragment";s:0:"";s:10:"mInterwiki";s:0:"";s:22:"TitlemLocalInterwiki";b:0;s:17:"*mUserCaseDBKey";s:12:"Jel_van_Rijn";s:17:"mDefaultNamespace";i:0;}}
    [4] => No page for workflow: O:19:"Flow\Model\Workflow":9:{s:5:"*id";O:15:"Flow\Model\UUID":1:{s:20:"*alphadecimalValue";s:16:"sv3duslc09cjqkr6";}s:7:"*type";s:10:"discussion";s:7:"*wiki";s:22:"permanentfuturelabwiki";s:9:"*pageId";i:0;s:12:"*namespace";i:1;s:12:"*titleText";s:29:"Permanent_Future_Lab_Strijp-S";s:14:"*lastUpdated";s:14:"20151223125222";s:8:"*title";N;s:13:"*ownerTitle";O:5:"Title":7:{s:10:"mNamespace";i:1;s:10:"mDbkeyform";s:29:"Permanent_Future_Lab_Strijp-S";s:9:"mFragment";s:0:"";s:10:"mInterwiki";s:0:"";s:22:"TitlemLocalInterwiki";b:0;s:17:"*mUserCaseDBKey";s:29:"Permanent_Future_Lab_Strijp-S";s:17:"mDefaultNamespace";i:0;}}
    [5] => No page for workflow: O:19:"Flow\Model\Workflow":9:{s:5:"*id";O:15:"Flow\Model\UUID":1:{s:20:"*alphadecimalValue";s:16:"sv3dusli8r353bma";}s:7:"*type";s:5:"topic";s:7:"*wiki";s:22:"permanentfuturelabwiki";s:9:"*pageId";i:0;s:12:"*namespace";i:1;s:12:"*titleText";s:29:"Permanent_Future_Lab_Strijp-S";s:14:"*lastUpdated";s:14:"20151223213826";s:8:"*title";N;s:13:"*ownerTitle";O:5:"Title":7:{s:10:"mNamespace";i:1;s:10:"mDbkeyform";s:29:"Permanent_Future_Lab_Strijp-S";s:9:"mFragment";s:0:"";s:10:"mInterwiki";s:0:"";s:22:"TitlemLocalInterwiki";b:0;s:17:"*mUserCaseDBKey";s:29:"Permanent_Future_Lab_Strijp-S";s:17:"mDefaultNamespace";i:0;}}
)


Failed: 6
Array
(
    [0] => stdClass Object
        (
            [workflow_id] => E�01�1�
            [workflow_wiki] => permanentfuturelabwiki
            [workflow_namespace] => 3
            [workflow_page_id] => 0
            [workflow_title_text] => Samir_Lahiri
            [workflow_name] =>
            [workflow_last_update_timestamp] => 20151206180950
            [workflow_lock_state] => 0
            [workflow_type] => discussion
        )

    [1] => stdClass Object
        (
            [workflow_id] => E�0=�1�
            [workflow_wiki] => permanentfuturelabwiki
            [workflow_namespace] => 3
            [workflow_page_id] => 0
            [workflow_title_text] => Samir_Lahiri
            [workflow_name] =>
            [workflow_last_update_timestamp] => 20151206180950
            [workflow_lock_state] => 0
            [workflow_type] => topic
        )

    [2] => stdClass Object
        (
            [workflow_id] => E�Y�1�
            [workflow_wiki] => permanentfuturelabwiki
            [workflow_namespace] => 3
            [workflow_page_id] => 0
            [workflow_title_text] => Jel_van_Rijn
            [workflow_name] =>
            [workflow_last_update_timestamp] => 20151207100638
            [workflow_lock_state] => 0
            [workflow_type] => discussion
        )

    [3] => stdClass Object
        (
            [workflow_id] => E�e�1�
            [workflow_wiki] => permanentfuturelabwiki
            [workflow_namespace] => 3
            [workflow_page_id] => 0
            [workflow_title_text] => Jel_van_Rijn
            [workflow_name] =>
            [workflow_last_update_timestamp] => 20151207105225
            [workflow_lock_state] => 0
            [workflow_type] => topic
        )

    [4] => stdClass Object
        (
            [workflow_id] => G;�I�1�
            [workflow_wiki] => permanentfuturelabwiki
            [workflow_namespace] => 1
            [workflow_page_id] => 0
            [workflow_title_text] => Permanent_Future_Lab_Strijp-S
            [workflow_name] =>
            [workflow_last_update_timestamp] => 20151223125222
            [workflow_lock_state] => 0
            [workflow_type] => discussion
        )

    [5] => stdClass Object
        (
            [workflow_id] => G;�Y�1�
            [workflow_wiki] => permanentfuturelabwiki
            [workflow_namespace] => 1
            [workflow_page_id] => 0
            [workflow_title_text] => Permanent_Future_Lab_Strijp-S
            [workflow_name] =>
            [workflow_last_update_timestamp] => 20151223213826
            [workflow_lock_state] => 0
            [workflow_type] => topic
        )

)

If I can provide you with the Flow database without revealing private information, please advise me how to.

Also, I run MediaWiki 1.26 and the REL1_26 version of this extension - not the master version.

Hi @Southparkfan:
I think I would only need an SQL dump of the flow_workflow table & the page table.
Apart from maybe workflow_title_text (in flow_workflow) and page_title (in page), there probably isn't any revealing info in either of those columns.
Feel free to email a dump of those tables to mmullie@wikimedia.org (or post it here)

You may also want to try opening Flow/Includes/Model/Workflow.php and find the line that throws the "No page for workflow" exception, and (temporarily) delete it.
Then try running the maintenance script again (and afterwards, reinstate that exception-line)


This is likely what you need

Change 265707 merged by jenkins-bot:
FlowUpdateWorkflowPageId.php: Check for fatal Status objs returned by OccupationController

https://gerrit.wikimedia.org/r/265707

@Southparkfan: have you tried running the latest version of the script (that has now been merged)
I just tried your dump on my machine, with the latest version of the script, and it succeeded:

Updated 6  workflows

Warnings: 0
Array
(
)


Failed: 0
Array
(
)

I use the latest version:

root@mw1:/srv/mediawiki/w/extensions/Flow/maintenance# php FlowUpdateWorkflowPageId.php --wiki permanentfuturelabwiki --force
Updated 0  workflows

Warnings: 6
Array
(
    [0] => No page for workflow: O:19:"Flow\Model\Workflow":9:{s:5:"*id";O:15:"Flow\Model\UUID":1:{s:20:"*alphadecimalValue";s:16:"su208cwu7tvsqt8y";}s:7:"*type";s:10:"discussion";s:7:"*wiki";s:22:"permanentfuturelabwiki";s:9:"*pageId";i:0;s:12:"*namespace";i:3;s:12:"*titleText";s:12:"Samir_Lahiri";s:14:"*lastUpdated";s:14:"20151206180950";s:8:"*title";N;s:13:"*ownerTitle";O:5:"Title":7:{s:10:"mNamespace";i:3;s:10:"mDbkeyform";s:12:"Samir_Lahiri";s:9:"mFragment";s:0:"";s:10:"mInterwiki";s:0:"";s:22:"TitlemLocalInterwiki";b:0;s:17:"*mUserCaseDBKey";s:12:"Samir_Lahiri";s:17:"mDefaultNamespace";i:0;}}
    [1] => No page for workflow: O:19:"Flow\Model\Workflow":9:{s:5:"*id";O:15:"Flow\Model\UUID":1:{s:20:"*alphadecimalValue";s:16:"su208cwyw76qrdea";}s:7:"*type";s:5:"topic";s:7:"*wiki";s:22:"permanentfuturelabwiki";s:9:"*pageId";i:0;s:12:"*namespace";i:3;s:12:"*titleText";s:12:"Samir_Lahiri";s:14:"*lastUpdated";s:14:"20151206180950";s:8:"*title";N;s:13:"*ownerTitle";O:5:"Title":7:{s:10:"mNamespace";i:3;s:10:"mDbkeyform";s:12:"Samir_Lahiri";s:9:"mFragment";s:0:"";s:10:"mInterwiki";s:0:"";s:22:"TitlemLocalInterwiki";b:0;s:17:"*mUserCaseDBKey";s:12:"Samir_Lahiri";s:17:"mDefaultNamespace";i:0;}}
    [2] => No page for workflow: O:19:"Flow\Model\Workflow":9:{s:5:"*id";O:15:"Flow\Model\UUID":1:{s:20:"*alphadecimalValue";s:16:"su3hilb4dxail6ky";}s:7:"*type";s:10:"discussion";s:7:"*wiki";s:22:"permanentfuturelabwiki";s:9:"*pageId";i:0;s:12:"*namespace";i:3;s:12:"*titleText";s:12:"Jel_van_Rijn";s:14:"*lastUpdated";s:14:"20151207100638";s:8:"*title";N;s:13:"*ownerTitle";O:5:"Title":7:{s:10:"mNamespace";i:3;s:10:"mDbkeyform";s:12:"Jel_van_Rijn";s:9:"mFragment";s:0:"";s:10:"mInterwiki";s:0:"";s:22:"TitlemLocalInterwiki";b:0;s:17:"*mUserCaseDBKey";s:12:"Jel_van_Rijn";s:17:"mDefaultNamespace";i:0;}}
    [3] => No page for workflow: O:19:"Flow\Model\Workflow":9:{s:5:"*id";O:15:"Flow\Model\UUID":1:{s:20:"*alphadecimalValue";s:16:"su3hilb92alglqqa";}s:7:"*type";s:5:"topic";s:7:"*wiki";s:22:"permanentfuturelabwiki";s:9:"*pageId";i:0;s:12:"*namespace";i:3;s:12:"*titleText";s:12:"Jel_van_Rijn";s:14:"*lastUpdated";s:14:"20151207105225";s:8:"*title";N;s:13:"*ownerTitle";O:5:"Title":7:{s:10:"mNamespace";i:3;s:10:"mDbkeyform";s:12:"Jel_van_Rijn";s:9:"mFragment";s:0:"";s:10:"mInterwiki";s:0:"";s:22:"TitlemLocalInterwiki";b:0;s:17:"*mUserCaseDBKey";s:12:"Jel_van_Rijn";s:17:"mDefaultNamespace";i:0;}}
    [4] => No page for workflow: O:19:"Flow\Model\Workflow":9:{s:5:"*id";O:15:"Flow\Model\UUID":1:{s:20:"*alphadecimalValue";s:16:"sv3duslc09cjqkr6";}s:7:"*type";s:10:"discussion";s:7:"*wiki";s:22:"permanentfuturelabwiki";s:9:"*pageId";i:0;s:12:"*namespace";i:1;s:12:"*titleText";s:29:"Permanent_Future_Lab_Strijp-S";s:14:"*lastUpdated";s:14:"20151223125222";s:8:"*title";N;s:13:"*ownerTitle";O:5:"Title":7:{s:10:"mNamespace";i:1;s:10:"mDbkeyform";s:29:"Permanent_Future_Lab_Strijp-S";s:9:"mFragment";s:0:"";s:10:"mInterwiki";s:0:"";s:22:"TitlemLocalInterwiki";b:0;s:17:"*mUserCaseDBKey";s:29:"Permanent_Future_Lab_Strijp-S";s:17:"mDefaultNamespace";i:0;}}
    [5] => No page for workflow: O:19:"Flow\Model\Workflow":9:{s:5:"*id";O:15:"Flow\Model\UUID":1:{s:20:"*alphadecimalValue";s:16:"sv3dusli8r353bma";}s:7:"*type";s:5:"topic";s:7:"*wiki";s:22:"permanentfuturelabwiki";s:9:"*pageId";i:0;s:12:"*namespace";i:1;s:12:"*titleText";s:29:"Permanent_Future_Lab_Strijp-S";s:14:"*lastUpdated";s:14:"20151223213826";s:8:"*title";N;s:13:"*ownerTitle";O:5:"Title":7:{s:10:"mNamespace";i:1;s:10:"mDbkeyform";s:29:"Permanent_Future_Lab_Strijp-S";s:9:"mFragment";s:0:"";s:10:"mInterwiki";s:0:"";s:22:"TitlemLocalInterwiki";b:0;s:17:"*mUserCaseDBKey";s:29:"Permanent_Future_Lab_Strijp-S";s:17:"mDefaultNamespace";i:0;}}
)


Failed: 6
Array
(
    [0] => stdClass Object
        (
            [workflow_id] => E▒▒01▒▒1▒
            [workflow_wiki] => permanentfuturelabwiki
            [workflow_namespace] => 3
            [workflow_page_id] => 0
            [workflow_title_text] => Samir_Lahiri
            [workflow_name] =>
            [workflow_last_update_timestamp] => 20151206180950
            [workflow_lock_state] => 0
            [workflow_type] => discussion
        )

    [1] => stdClass Object
        (
            [workflow_id] => E▒▒0=▒▒1▒
            [workflow_wiki] => permanentfuturelabwiki
            [workflow_namespace] => 3
            [workflow_page_id] => 0
            [workflow_title_text] => Samir_Lahiri
            [workflow_name] =>
            [workflow_last_update_timestamp] => 20151206180950
            [workflow_lock_state] => 0
            [workflow_type] => topic
        )

    [2] => stdClass Object
        (
            [workflow_id] => E▒Y▒▒1▒
            [workflow_wiki] => permanentfuturelabwiki
            [workflow_namespace] => 3
            [workflow_page_id] => 0
            [workflow_title_text] => Jel_van_Rijn
            [workflow_name] =>
            [workflow_last_update_timestamp] => 20151207100638
            [workflow_lock_state] => 0
            [workflow_type] => discussion
        )

    [3] => stdClass Object
        (
            [workflow_id] => E▒e▒▒1▒
            [workflow_wiki] => permanentfuturelabwiki
            [workflow_namespace] => 3
            [workflow_page_id] => 0
            [workflow_title_text] => Jel_van_Rijn
            [workflow_name] =>
            [workflow_last_update_timestamp] => 20151207105225
            [workflow_lock_state] => 0
            [workflow_type] => topic
        )

    [4] => stdClass Object
        (
            [workflow_id] => G;▒I▒▒1▒
            [workflow_wiki] => permanentfuturelabwiki
            [workflow_namespace] => 1
            [workflow_page_id] => 0
            [workflow_title_text] => Permanent_Future_Lab_Strijp-S
            [workflow_name] =>
            [workflow_last_update_timestamp] => 20151223125222
            [workflow_lock_state] => 0
            [workflow_type] => discussion
        )

    [5] => stdClass Object
        (
            [workflow_id] => G;▒Y▒▒1▒
            [workflow_wiki] => permanentfuturelabwiki
            [workflow_namespace] => 1
            [workflow_page_id] => 0
            [workflow_title_text] => Permanent_Future_Lab_Strijp-S
            [workflow_name] =>
            [workflow_last_update_timestamp] => 20151223213826
            [workflow_lock_state] => 0
            [workflow_type] => topic
        )

)
root@mw1:/srv/mediawiki/w/extensions/Flow/maintenance# git diff
diff --git a/maintenance/FlowUpdateWorkflowPageId.php b/maintenance/FlowUpdateWorkflowPageId.php
index 7ff32a1..aecff80 100644
--- a/maintenance/FlowUpdateWorkflowPageId.php
+++ b/maintenance/FlowUpdateWorkflowPageId.php
@@ -2,6 +2,7 @@

 use Flow\Container;
 use Flow\Model\UUID;
+use Flow\Model\Workflow;
 use Flow\OccupationController;

 $IP = getenv( 'MW_INSTALL_PATH' );
@@ -9,7 +10,7 @@ if ( $IP === false ) {
        $IP = dirname( __FILE__ ) . '/../../..';
 }
 require_once( "$IP/maintenance/Maintenance.php" );
-require_once __DIR__ . "/../../Echo/includes/BatchRowUpdate.php";
+require_once( "$IP/includes/utils/RowUpdateGenerator.php" );

 /**
  * In some cases we have created workflow instances before the related Title
@@ -33,7 +34,7 @@ class FlowUpdateWorkflowPageId extends LoggedUpdateMaintenance {

                $dbw = Container::get( 'db.factory' )->getDB( DB_MASTER );

-               $it = new EchoBatchRowIterator(
+               $it = new BatchRowIterator(
                        $dbw,
                        'flow_workflow',
                        'workflow_id',
@@ -45,8 +46,8 @@ class FlowUpdateWorkflowPageId extends LoggedUpdateMaintenance {
                ) );

                $gen = new WorkflowPageIdUpdateGenerator( $wgLang );
-               $writer = new EchoBatchRowWriter( $dbw, 'flow_workflow', $wgFlowCluster );
-               $updater = new EchoBatchRowUpdate( $it, $writer, $gen );
+               $writer = new BatchRowWriter( $dbw, 'flow_workflow', $wgFlowCluster );
+               $updater = new BatchRowUpdate( $it, $writer, $gen );

                $updater->execute();

@@ -64,13 +65,14 @@ class FlowUpdateWorkflowPageId extends LoggedUpdateMaintenance {
[And more... cutting here because it should be clear now I use the latest version..]

Hi all. I think the debugging takes to much time. We are not able to use flow for a 3 months now. Is it possible to get the input/discussions till now? It aren't that much, I guess 5 till 10. And start from scratch without the bug?

Change 260902 abandoned by Mattflaschen:
DO NOT MERGE: Output exception to help track down an issue

https://gerrit.wikimedia.org/r/260902

Hi all. I think the debugging takes to much time. We are not able to use flow for a 3 months now. Is it possible to get the input/discussions till now? It aren't that much, I guess 5 till 10. And start from scratch without the bug?

Unfortunately, XML dumps of Flow content will not be available until 1.27 (master change is rEFLWe4ba61627c37: Dump Flow data).

jmatazzoni closed this task as Resolved.Apr 12 2016, 6:49 PM
Mattflaschen-WMF changed the task status from Resolved to Declined.Apr 15 2016, 5:49 PM
Seb35 added a subscriber: Seb35.Jun 4 2016, 5:20 PM

FYI I had the same problem on a wiki where Flow was installed from the beginning (no talk pages existed with traditional wikitext and talk pages were red as in T115201). There were 70 pages. This problem occured when upgrading from 1.25.5 to 1.26.3.
I solved it with the following upgrade path:

  1. upgrade MediaWiki and all extensions to 1.26 (with git, but probably the same with tarballs)
  2. upgrade Flow extension from 1.25 to 1.27 (with git, but probably the same with tarballs)
  3. in the composer.local.json in the root directory of MediaWiki, add the dependency "wikimedia/base-convert": "1.0.1" (this is needed by Flow 1.27 but not included in MediaWiki 1.26); run Composer in the root directory of MediaWiki
  4. run: php extensions/Flow/maintenance/FlowUpdateWorkflowPageId.php --force
  5. if you prefer, return to Flow 1.26 and remove wikimedia/base-convert in Composer

(btw, it took me about 5 hours to solve it, I hope this comment can save hours to other people.)